/**
 * TrueReality - N64/compile_static_tab.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#ifndef __TR_COMPILE_STATIC_TAB_H
#define __TR_COMPILE_STATIC_TAB_H





#include "compile_static.h"










/* exceptions? */
static void tr_reserved();
static void tr_invalid();
static void tr_unimplemented();

/* special functions */
static void tr_SLL();
#if 0   /* this is not used very often - niki */
static void tr_SLL_opt();
#endif
static void tr_NOP_opt();
static void tr_CLR_opt();
static void tr_SRL();
static void tr_SRA();
static void tr_SLLV();
static void tr_SRLV();
static void tr_SRAV();
static void tr_JR();
static void tr_JALR();
static void tr_SYSCALL();
static void tr_BREAK();
static void tr_SYNC();
static void tr_MFHI();
static void tr_MTHI();
static void tr_MFLO();
static void tr_MTLO();
static void tr_DSLLV();
static void tr_DSRLV();
static void tr_DSRAV();
static void tr_MULT();
static void tr_MULTU();
static void tr_DIV();
static void tr_DIVU();
static void tr_DMULT();
static void tr_DMULTU();
static void tr_DDIV();
static void tr_DDIVU();
static void tr_ADD();
static void tr_ADDU();
static void tr_SUB();
static void tr_SUBU();
static void tr_AND();
static void tr_OR();
static void tr_XOR();
static void tr_NOR();
static void tr_SLT();
static void tr_SLTU();
static void tr_DADD();
static void tr_DADDU();
static void tr_DSUB();
static void tr_DSUBU();
static void tr_TGE();
static void tr_TGEU();
static void tr_TLT();
static void tr_TLTU();
static void tr_TEQ();
static void tr_TNE();
static void tr_DSLL();
static void tr_DSRL();
static void tr_DSRA();
static void tr_DSLL32();
static void tr_DSRL32();
static void tr_DSRA32();

/* core functions */
static void tr_J();
static void tr_JAL();
static void tr_BEQ();
static void tr_BNE();
static void tr_BLEZ();
static void tr_BGTZ();
static void tr_ADDI();
static void tr_ADDIU();
static void tr_SLTI();
static void tr_SLTIU();
static void tr_ANDI();
static void tr_ORI();
static void tr_XORI();
static void tr_LUI();
static void tr_BEQL();
static void tr_BNEL();
static void tr_BLEZL();
static void tr_BGTZL();
static void tr_DADDI();
static void tr_DADDIU();
static void tr_LDL();
static void tr_LDR();
static void tr_LB();
static void tr_LH();
static void tr_LWL();
static void tr_LW();
static void tr_LBU();
static void tr_LHU();
static void tr_LWR();
static void tr_LWU();
static void tr_SB();
static void tr_SH();
static void tr_SWL();
static void tr_SW();
static void tr_SDL();
static void tr_SDR();
static void tr_SWR();
static void tr_CACHE();
static void tr_LL();
static void tr_LWC1();
static void tr_LWC2();
static void tr_LLD();
static void tr_LDC1();
static void tr_LDC2();
static void tr_LD();
static void tr_SC();
static void tr_SWC1();
static void tr_SWC2();
static void tr_SCD();
static void tr_SDC1();
static void tr_SDC2();
static void tr_SD();

/* REGister IMMediate functions */
static void tr_regimm_BLTZ();
static void tr_regimm_BGEZ();
static void tr_regimm_BLTZL();
static void tr_regimm_BGEZL();
static void tr_regimm_TGEI();
static void tr_regimm_TGEIU();
static void tr_regimm_TLTI();
static void tr_regimm_TLTIU();
static void tr_regimm_TEQI();
static void tr_regimm_TNEI();
static void tr_regimm_BLTZAL();
static void tr_regimm_BGEZAL();
static void tr_regimm_BLTZALL();
static void tr_regimm_BGEZALL();

/* cop0 (TranslationLookasideBuffer / ExceptionRETurn) */
static void tr_MFC0();
static void tr_DMFC0();
static void tr_CFC0();
static void tr_MTC0();
static void tr_DMTC0();
static void tr_CTC0();
static void tr_BC0F();
static void tr_BC0T();
static void tr_BC0FL();
static void tr_BC0TL();
static void tr_cop0_TLBR();
static void tr_cop0_TLBWI();
static void tr_cop0_TLBWR();
static void tr_cop0_TLBP();
static void tr_cop0_ERET();

/* cop1 (FloatingPointUnit) */
static void tr_MFC1();
static void tr_DMFC1();
static void tr_CFC1();
static void tr_MTC1();
static void tr_DMTC1();
static void tr_CTC1();
static void tr_BC1F();
static void tr_BC1T();
static void tr_BC1FL();
static void tr_BC1TL();
static void tr_cop1_ADD_s();
static void tr_cop1_ADD_d();
static void tr_cop1_SUB_s();
static void tr_cop1_SUB_d();
static void tr_cop1_MUL_s();
static void tr_cop1_MUL_d();
static void tr_cop1_DIV_s();
static void tr_cop1_DIV_d();
static void tr_cop1_SQRT_s();
static void tr_cop1_SQRT_d();
static void tr_cop1_ABS_s();
static void tr_cop1_ABS_d();
static void tr_cop1_MOV_s();
static void tr_cop1_MOV_d();
static void tr_cop1_NEG_s();
static void tr_cop1_NEG_d();
static void tr_cop1_ROUNDl_s();
static void tr_cop1_ROUNDl_d();
static void tr_cop1_TRUNCl_s();
static void tr_cop1_TRUNCl_d();
static void tr_cop1_CEILl_s();
static void tr_cop1_CEILl_d();
static void tr_cop1_FLOORl_s();
static void tr_cop1_FLOORl_d();
static void tr_cop1_ROUNDw_s();
static void tr_cop1_ROUNDw_d();
static void tr_cop1_TRUNCw_s();
static void tr_cop1_TRUNCw_d();
static void tr_cop1_CEILw_s();
static void tr_cop1_CEILw_d();
static void tr_cop1_FLOORw_s();
static void tr_cop1_FLOORw_d();
static void tr_cop1_CVTs_d();
static void tr_cop1_CVTs_w();
static void tr_cop1_CVTs_l();
static void tr_cop1_CVTd_s();
static void tr_cop1_CVTd_w();
static void tr_cop1_CVTd_l();
static void tr_cop1_CVTw_s();
static void tr_cop1_CVTw_d();
static void tr_cop1_CVTl_s();
static void tr_cop1_CVTl_d();
static void tr_cop1_CF_s();
static void tr_cop1_CF_d();
static void tr_cop1_CUN_s();
static void tr_cop1_CUN_d();
static void tr_cop1_CEQ_s();
static void tr_cop1_CEQ_d();
static void tr_cop1_CUEQ_s();
static void tr_cop1_CUEQ_d();
static void tr_cop1_COLT_s();
static void tr_cop1_COLT_d();
static void tr_cop1_CULT_s();
static void tr_cop1_CULT_d();
static void tr_cop1_COLE_s();
static void tr_cop1_COLE_d();
static void tr_cop1_CULE_s();
static void tr_cop1_CULE_d();
static void tr_cop1_CSF_s();
static void tr_cop1_CSF_d();
static void tr_cop1_CNGLE_s();
static void tr_cop1_CNGLE_d();
static void tr_cop1_CSEQ_s();
static void tr_cop1_CSEQ_d();
static void tr_cop1_CNGL_s();
static void tr_cop1_CNGL_d();
static void tr_cop1_CLT_s();
static void tr_cop1_CLT_d();
static void tr_cop1_CNGE_s();
static void tr_cop1_CNGE_d();
static void tr_cop1_CLE_s();
static void tr_cop1_CLE_d();
static void tr_cop1_CNGT_s();
static void tr_cop1_CNGT_d();










/* exceptions? */
static void gen_reserved(tr_u32, tr_instruction *);

/* special functions */
static void gen_SLL(tr_u32, tr_instruction *);
static void gen_SRL(tr_u32, tr_instruction *);
static void gen_SRA(tr_u32, tr_instruction *);
static void gen_SLLV(tr_u32, tr_instruction *);
static void gen_SRLV(tr_u32, tr_instruction *);
static void gen_SRAV(tr_u32, tr_instruction *);
static void gen_JR(tr_u32, tr_instruction *);
static void gen_JALR(tr_u32, tr_instruction *);
static void gen_SYSCALL(tr_u32, tr_instruction *);
static void gen_BREAK(tr_u32, tr_instruction *);
static void gen_SYNC(tr_u32, tr_instruction *);
static void gen_MFHI(tr_u32, tr_instruction *);
static void gen_MTHI(tr_u32, tr_instruction *);
static void gen_MFLO(tr_u32, tr_instruction *);
static void gen_MTLO(tr_u32, tr_instruction *);
static void gen_DSLLV(tr_u32, tr_instruction *);
static void gen_DSRLV(tr_u32, tr_instruction *);
static void gen_DSRAV(tr_u32, tr_instruction *);
static void gen_MULT(tr_u32, tr_instruction *);
static void gen_MULTU(tr_u32, tr_instruction *);
static void gen_DIV(tr_u32, tr_instruction *);
static void gen_DIVU(tr_u32, tr_instruction *);
static void gen_DMULT(tr_u32, tr_instruction *);
static void gen_DMULTU(tr_u32, tr_instruction *);
static void gen_DDIV(tr_u32, tr_instruction *);
static void gen_DDIVU(tr_u32, tr_instruction *);
static void gen_ADD(tr_u32, tr_instruction *);
static void gen_ADDU(tr_u32, tr_instruction *);
static void gen_SUB(tr_u32, tr_instruction *);
static void gen_SUBU(tr_u32, tr_instruction *);
static void gen_AND(tr_u32, tr_instruction *);
static void gen_OR(tr_u32, tr_instruction *);
static void gen_XOR(tr_u32, tr_instruction *);
static void gen_NOR(tr_u32, tr_instruction *);
static void gen_SLT(tr_u32, tr_instruction *);
static void gen_SLTU(tr_u32, tr_instruction *);
static void gen_DADD(tr_u32, tr_instruction *);
static void gen_DADDU(tr_u32, tr_instruction *);
static void gen_DSUB(tr_u32, tr_instruction *);
static void gen_DSUBU(tr_u32, tr_instruction *);
static void gen_TGE(tr_u32, tr_instruction *);
static void gen_TGEU(tr_u32, tr_instruction *);
static void gen_TLT(tr_u32, tr_instruction *);
static void gen_TLTU(tr_u32, tr_instruction *);
static void gen_TEQ(tr_u32, tr_instruction *);
static void gen_TNE(tr_u32, tr_instruction *);
static void gen_DSLL(tr_u32, tr_instruction *);
static void gen_DSRL(tr_u32, tr_instruction *);
static void gen_DSRA(tr_u32, tr_instruction *);
static void gen_DSLL32(tr_u32, tr_instruction *);
static void gen_DSRL32(tr_u32, tr_instruction *);
static void gen_DSRA32(tr_u32, tr_instruction *);

/* core functions */
static void gen_regimm(tr_u32, tr_instruction *);
static void gen_J(tr_u32, tr_instruction *);
static void gen_JAL(tr_u32, tr_instruction *);
static void gen_BEQ(tr_u32, tr_instruction *);
static void gen_BNE(tr_u32, tr_instruction *);
static void gen_BLEZ(tr_u32, tr_instruction *);
static void gen_BGTZ(tr_u32, tr_instruction *);
static void gen_ADDI(tr_u32, tr_instruction *);
static void gen_ADDIU(tr_u32, tr_instruction *);
static void gen_SLTI(tr_u32, tr_instruction *);
static void gen_SLTIU(tr_u32, tr_instruction *);
static void gen_ANDI(tr_u32, tr_instruction *);
static void gen_ORI(tr_u32, tr_instruction *);
static void gen_XORI(tr_u32, tr_instruction *);
static void gen_LUI(tr_u32, tr_instruction *);
static void gen_cop0(tr_u32, tr_instruction *);
static void gen_cop1(tr_u32, tr_instruction *);
static void gen_cop2(tr_u32, tr_instruction *);   /* not used */
static void gen_BEQL(tr_u32, tr_instruction *);
static void gen_BNEL(tr_u32, tr_instruction *);
static void gen_BLEZL(tr_u32, tr_instruction *);
static void gen_BGTZL(tr_u32, tr_instruction *);
static void gen_DADDI(tr_u32, tr_instruction *);
static void gen_DADDIU(tr_u32, tr_instruction *);
static void gen_LDL(tr_u32, tr_instruction *);
static void gen_LDR(tr_u32, tr_instruction *);
static void gen_LB(tr_u32, tr_instruction *);
static void gen_LH(tr_u32, tr_instruction *);
static void gen_LWL(tr_u32, tr_instruction *);
static void gen_LW(tr_u32, tr_instruction *);
static void gen_LBU(tr_u32, tr_instruction *);
static void gen_LHU(tr_u32, tr_instruction *);
static void gen_LWR(tr_u32, tr_instruction *);
static void gen_LWU(tr_u32, tr_instruction *);
static void gen_SB(tr_u32, tr_instruction *);
static void gen_SH(tr_u32, tr_instruction *);
static void gen_SWL(tr_u32, tr_instruction *);
static void gen_SW(tr_u32, tr_instruction *);
static void gen_SDL(tr_u32, tr_instruction *);
static void gen_SDR(tr_u32, tr_instruction *);
static void gen_SWR(tr_u32, tr_instruction *);
static void gen_CACHE(tr_u32, tr_instruction *);
static void gen_LL(tr_u32, tr_instruction *);
static void gen_LWC1(tr_u32, tr_instruction *);
static void gen_LWC2(tr_u32, tr_instruction *);
static void gen_LLD(tr_u32, tr_instruction *);
static void gen_LDC1(tr_u32, tr_instruction *);
static void gen_LDC2(tr_u32, tr_instruction *);
static void gen_LD(tr_u32, tr_instruction *);
static void gen_SC(tr_u32, tr_instruction *);
static void gen_SWC1(tr_u32, tr_instruction *);
static void gen_SWC2(tr_u32, tr_instruction *);
static void gen_SCD(tr_u32, tr_instruction *);
static void gen_SDC1(tr_u32, tr_instruction *);
static void gen_SDC2(tr_u32, tr_instruction *);
static void gen_SD(tr_u32, tr_instruction *);










void (*tr_compile_tab[4096])(tr_u32 code, tr_instruction *dest) =
{
    /* special */
        gen_SLL,      gen_reserved, gen_SRL,      gen_SRA,      gen_SLLV,     gen_reserved, gen_SRLV,     gen_SRAV,
        gen_JR,       gen_JALR,     gen_reserved, gen_reserved, gen_SYSCALL,  gen_BREAK,    gen_reserved, gen_SYNC,
        gen_MFHI,     gen_MTHI,     gen_MFLO,     gen_MTLO,     gen_DSLLV,    gen_reserved, gen_DSRLV,    gen_DSRAV,
        gen_MULT,     gen_MULTU,    gen_DIV,      gen_DIVU,     gen_DMULT,    gen_DMULTU,   gen_DDIV,     gen_DDIVU,
        gen_ADD,      gen_ADDU,     gen_SUB,      gen_SUBU,     gen_AND,      gen_OR,       gen_XOR,      gen_NOR,
        gen_reserved, gen_reserved, gen_SLT,      gen_SLTU,     gen_DADD,     gen_DADDU,    gen_DSUB,     gen_DSUBU,
        gen_TGE,      gen_TGEU,     gen_TLT,      gen_TLTU,     gen_TEQ,      gen_reserved, gen_TNE,      gen_reserved,
        gen_DSLL,     gen_reserved, gen_DSRL,     gen_DSRA,     gen_DSLL32,   gen_reserved, gen_DSRL32,   gen_DSRA32,

    /* regimm */
        /* have to check rt before, then:
                gen_bltz,
                gen_bgez,
                gen_bltzl,
                gen_bgezl,
                gen_tgei,
                gen_tgeiu,
                gen_tlti,
                gen_tltiu,
                gen_teqi,
                gen_tnei,
                gen_bltzal,
                gen_bgezal,
                gen_bltzall,
                gen_bgezall
        */
        gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm,  
        gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm,  
        gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm,  
        gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm,  
        gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm,  
        gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm,  
        gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm,  
        gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm, gen_regimm,  
        
    /* rs4300i_j */
        gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J,
        gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J,
        gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J,
        gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J,
        gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J,
        gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J,
        gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J,
        gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J, gen_J,

    /* rs4300i_jal */
        gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL,
        gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL,
        gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL,
        gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL,
        gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL,
        gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL,
        gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL,
        gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL, gen_JAL,

    /* rs4300i_beq */
        gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ,
        gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ,
        gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ,
        gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ,
        gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ,
        gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ,
        gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ,
        gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ, gen_BEQ,

    /* rs4300i_bne */
        gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE,
        gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE,
        gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE,
        gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE,
        gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE,
        gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE,
        gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE,
        gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE, gen_BNE,

    /* rs4300i_blez */
        gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ,
        gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ,
        gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ,
        gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ,
        gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ,
        gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ,
        gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ,
        gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ, gen_BLEZ,

    /* rs4300i_bgtz */
        gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ,
        gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ,
        gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ,
        gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ,
        gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ,
        gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ,
        gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ,
        gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ, gen_BGTZ,

    /* rs4300i_addi */
        gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI,
        gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI,
        gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI,
        gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI,
        gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI,
        gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI,
        gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI,
        gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI, gen_ADDI,

    /* rs4300i_addiu */
        gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU,
        gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU,
        gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU,
        gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU,
        gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU,
        gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU,
        gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU,
        gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU, gen_ADDIU,

    /* rs4300i_slti */
        gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI,
        gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI,
        gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI,
        gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI,
        gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI,
        gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI,
        gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI,
        gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI, gen_SLTI,

    /* rs4300i_sltiu */
        gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU,
        gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU,
        gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU,
        gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU,
        gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU,
        gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU,
        gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU,
        gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU, gen_SLTIU,

    /* rs4300i_andi */
        gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI,
        gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI,
        gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI,
        gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI,
        gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI,
        gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI,
        gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI,
        gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI, gen_ANDI,

    /* rs4300i_ori */
        gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI,
        gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI,
        gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI,
        gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI,
        gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI,
        gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI,
        gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI,
        gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI, gen_ORI,

    /* rs4300i_xori */
        gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI,
        gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI,
        gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI,
        gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI,
        gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI,
        gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI,
        gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI,
        gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI, gen_XORI,

    /* rs4300i_lui */
        gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI,
        gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI,
        gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI,
        gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI,
        gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI,
        gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI,
        gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI,
        gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI, gen_LUI,

    /* rs4300i_cop0 */
        /*
            we have to check rs!
                00000: mf
                00001: dmf
                00010: cf
                00100: mt
                00101: dmt
                00110: ct
                01000: bc -> check rt -> bcf, bct, bcfl, bctl or reserved instruction
                10xxx: function, invalid operation or reserved instruction exception
                other: reserved instruction exception
        */
        gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0,
        gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0,
        gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0,
        gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0,
        gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0,
        gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0,
        gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0,
        gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0, gen_cop0,

    /* rs4300i_cop1 */
        /*
            we have to check rs!:
                00000: mf
                00001: dmf
                00010: cf
                00100: mt
                00101: dmt
                00110: ct
                01000: bc -> check rt -> bcf, bct, bcfl, bctl or reserved instruction
                10000: s-function
                10001: d-function
                10100: w-function
                10101: l-function
                other: unimplemented operation exception
        */
        gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1,
        gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1,
        gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1,
        gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1,
        gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1,
        gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1,
        gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1,
        gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1, gen_cop1,

    /* rs4300i_cop2 */
        gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2,
        gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2,
        gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2,
        gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2,
        gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2,
        gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2,
        gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2,
        gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2, gen_cop2,

    /* reserved */
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,

    /* rs4300i_beql */
        gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL,
        gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL,
        gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL,
        gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL,
        gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL,
        gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL,
        gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL,
        gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL, gen_BEQL,

    /* rs4300i_bnel */
        gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL,
        gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL,
        gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL,
        gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL,
        gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL,
        gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL,
        gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL,
        gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL, gen_BNEL,

    /* rs4300i_blezl */
        gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL,
        gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL,
        gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL,
        gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL,
        gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL,
        gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL,
        gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL,
        gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL, gen_BLEZL,

    /* rs4300i_bgtzl */
        gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL,
        gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL,
        gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL,
        gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL,
        gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL,
        gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL,
        gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL,
        gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL, gen_BGTZL,

    /* rs4300i_daddi */
        gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI,
        gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI,
        gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI,
        gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI,
        gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI,
        gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI,
        gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI,
        gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI, gen_DADDI,

    /* rs4300i_daddiu */
        gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU,
        gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU,
        gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU,
        gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU,
        gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU,
        gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU,
        gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU,
        gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU, gen_DADDIU,

    /* rs4300i_ldl */
        gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL,
        gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL,
        gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL,
        gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL,
        gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL,
        gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL,
        gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL,
        gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL, gen_LDL,

    /* rs4300i_ldr */
        gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR,
        gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR,
        gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR,
        gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR,
        gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR,
        gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR,
        gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR,
        gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR, gen_LDR,

    /* reserved */
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,

    /* reserved */
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,

    /* reserved */
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,

    /* reserved */
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,

    /* rs4300i_lb */
        gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB,
        gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB,
        gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB,
        gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB,
        gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB,
        gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB,
        gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB,
        gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB, gen_LB,

    /* rs4300i_lh */
        gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH,
        gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH,
        gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH,
        gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH,
        gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH,
        gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH,
        gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH,
        gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH, gen_LH,

    /* rs4300i_lwl */
        gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL,
        gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL,
        gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL,
        gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL,
        gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL,
        gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL,
        gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL,
        gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL, gen_LWL,

    /* rs4300i_lw */
        gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW,
        gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW,
        gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW,
        gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW,
        gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW,
        gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW,
        gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW,
        gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW, gen_LW,

    /* rs4300i_lbu */
        gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU,
        gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU,
        gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU,
        gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU,
        gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU,
        gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU,
        gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU,
        gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU, gen_LBU,

    /* rs4300i_lhu */
        gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU,
        gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU,
        gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU,
        gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU,
        gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU,
        gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU,
        gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU,
        gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU, gen_LHU,

    /* rs4300i_lwr */
        gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR,
        gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR,
        gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR,
        gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR,
        gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR,
        gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR,
        gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR,
        gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR, gen_LWR,

    /* rs4300i_lwu */
        gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU,
        gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU,
        gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU,
        gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU,
        gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU,
        gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU,
        gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU,
        gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU, gen_LWU,

    /* rs4300i_sb */
        gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB,
        gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB,
        gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB,
        gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB,
        gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB,
        gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB,
        gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB,
        gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB, gen_SB,

    /* rs4300i_sh */
        gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH,
        gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH,
        gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH,
        gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH,
        gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH,
        gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH,
        gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH,
        gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH, gen_SH,

    /* rs4300i_swl */
        gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL,
        gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL,
        gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL,
        gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL,
        gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL,
        gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL,
        gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL,
        gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL, gen_SWL,

    /* rs4300i_sw */
        gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW,
        gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW,
        gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW,
        gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW,
        gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW,
        gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW,
        gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW,
        gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW, gen_SW,

    /* rs4300i_sdl */
        gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL,
        gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL,
        gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL,
        gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL,
        gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL,
        gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL,
        gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL,
        gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL, gen_SDL,

    /* rs4300i_sdr */
        gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR,
        gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR,
        gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR,
        gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR,
        gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR,
        gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR,
        gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR,
        gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR, gen_SDR,

    /* rs4300i_swr */
        gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR,
        gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR,
        gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR,
        gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR,
        gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR,
        gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR,
        gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR,
        gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR, gen_SWR,

    /* rs4300i_cache */
        gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE,
        gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE,
        gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE,
        gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE,
        gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE,
        gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE,
        gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE,
        gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE, gen_CACHE,

    /* rs4300i_ll */
        gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL,
        gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL,
        gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL,
        gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL,
        gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL,
        gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL,
        gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL,
        gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL, gen_LL,

    /* rs4300i_lwc1 */
        gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1,
        gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1,
        gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1,
        gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1,
        gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1,
        gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1,
        gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1,
        gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1, gen_LWC1,

    /* rs4300i_lwc2 */
        gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2,
        gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2,
        gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2,
        gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2,
        gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2,
        gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2,
        gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2,
        gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2, gen_LWC2,

    /* reserved */
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,

    /* rs4300i_lld */
        gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD,
        gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD,
        gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD,
        gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD,
        gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD,
        gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD,
        gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD,
        gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD, gen_LLD,

    /* rs4300i_ldc1 */
        gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1,
        gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1,
        gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1,
        gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1,
        gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1,
        gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1,
        gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1,
        gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1, gen_LDC1,

    /* rs4300i_ldc2 */
        gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2,
        gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2,
        gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2,
        gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2,
        gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2,
        gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2,
        gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2,
        gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2, gen_LDC2,

    /* rs4300i_ld */
        gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD,
        gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD,
        gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD,
        gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD,
        gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD,
        gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD,
        gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD,
        gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD, gen_LD,

    /* rs4300i_sc */
        gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC,
        gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC,
        gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC,
        gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC,
        gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC,
        gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC,
        gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC,
        gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC, gen_SC,

    /* rs4300i_swc1 */
        gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1,
        gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1,
        gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1,
        gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1,
        gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1,
        gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1,
        gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1,
        gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1, gen_SWC1,

    /* rs4300i_swc2 */
        gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2,
        gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2,
        gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2,
        gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2,
        gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2,
        gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2,
        gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2,
        gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2, gen_SWC2,

    /* reserved */
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,
        gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved, gen_reserved,

    /* rs4300i_scd */
        gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD,
        gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD,
        gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD,
        gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD,
        gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD,
        gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD,
        gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD,
        gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD, gen_SCD,

    /* rs4300i_sdc1 */
        gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1,
        gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1,
        gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1,
        gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1,
        gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1,
        gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1,
        gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1,
        gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1, gen_SDC1,

    /* rs4300i_sdc2 */
        gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2,
        gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2,
        gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2,
        gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2,
        gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2,
        gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2,
        gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2,
        gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2, gen_SDC2,

    /* rs4300i_sd */
        gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD,
        gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD,
        gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD,
        gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD,
        gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD,
        gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD,
        gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD,
        gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD, gen_SD,

}; /* void (*tr_compile_tab[4096])(tr_u32 code, tr_instruction *dest) */










#endif /* #ifndef __TR_COMPILE_STATIC_TAB_H */
