/**
 * TrueReality - N64/interrupts.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#ifndef __TR_INTERRUPTS_H
#define __TR_INTERRUPTS_H





#include "exceptions.h"

#include <type_sizes.h>





#define MI_INTR_NO      0x00
#define MI_INTR_ALL     0x3f
#define MI_INTR_SP      0x01
#define MI_INTR_SI      0x02
#define MI_INTR_AI      0x04
#define MI_INTR_VI      0x08
#define MI_INTR_PI      0x10
#define MI_INTR_DP      0x20

#define INTR_COUNT      0x80000001





extern tr_u32 next_interrupt_count;





void rs4300i_InitInterrupts();

void rs4300i_MI_Intr_SP();
void rs4300i_MI_Intr_SI();
void rs4300i_MI_Intr_AI();
void rs4300i_MI_Intr_PI();
void rs4300i_MI_Intr_DP();
void rs4300i_VI_or_CP_interrupt();
void rs4300i_VI_or_CP_calc();

void rs4300i_Check_MI_Interrupts();
void rs4300i_Check_CPU_Interrupts();





#endif /* #ifndef __TR_INTERRUPTS_H */

