/**
 * TrueReality - N64/memory.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#ifndef __MEMORY_H
#define __MEMORY_H





#include "type_sizes.h"





/* the "main" routines */

int     tr_n64_memory_alloc();
void    tr_n64_memory_clear();
void    tr_n64_memory_free();



/* the mem read routines */

#ifdef MACOS
        tr_u32   *doGetMemPtr(tr_u32 where);
#endif

tr_u8   doReadMemByte(tr_u32 where);
tr_u16  doReadMemHalfWord(tr_u32 where);
tr_u32  doReadMemWord(tr_u32 where);
tr_u64  doReadMemDoubleWord(tr_u32 where);



/* the mem write routines */

void    doWriteMemByte(tr_u8 what, tr_u32 where);
void    doWriteMemHalfWord(tr_u16 what, tr_u32 where);
void    doWriteMemWord(tr_u32 what, tr_u32 where);
void    doWriteMemDoubleWord(tr_u64 what, tr_u32 where);





#endif /* #ifndef __MEMORY_H */

