/**
 * TrueReality - include/config.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#define __CONFIG_H



/******************************************************\
*                                                      *
*  !!!     DON'T CHANGE ANYTHING IN THIS FILE     !!!  *
*                                                      *
*  !!! Everything can be changed in Makefile.tmpl !!!  *
*                                                      *
\******************************************************/





/* the following 3 defines are used with DISPLAY_SUPPORT in Makefile */
#define SUPPORT_LOCAL_DISPLAY           1
#define SUPPORT_LOCAL_DISPLAY_PROCESS   2
#define SUPPORT_REMOTE_DISPLAY          4

#ifndef OS_RESET
    #define OS_RESET
#endif

#ifdef TARGET_OS_MAC
        #define MACOS
        
        #ifndef bool
            #define bool unsigned char
        #endif
        
        #define DISPLAY_SUPPORT  0x07
        #define COMMAND_DEPTH
        #define WITH_ZLIB
        #define TR_HALT
        #define HLE
        #define FAST_MEMORY
        #define SPEED_HACK
        #define JUST3D
        #define OPENGL
//      #define NATIVE
//      #define DEBUG
//      #define AUDIO
       
        #define DISPLAY 1
       
//      #undef SUPPORT_LOCAL_DISPLAY
        #undef SUPPORT_LOCAL_DISPLAY_PROCESS
        #undef SUPPORT_REMOTE_DISPLAY
        
        bool IsInIgnoreList(unsigned long addr);
        extern char gHaltInstrStr[256];
        extern unsigned long gIgnoreAddr;

#undef  OS_RESET
#define OS_RESET CpuResetMac();
        void CpuResetMac();
        
        #ifdef TARGET_CPU_PPC
                #define PPC
        #elif TARGET_CPU_68K
                #define M68K
        #endif
        
        #ifdef TARGET_RT_BIG_ENDIAN
                #define TR_ENDIAN_IS_BIG
        #elif TARGET_RT_LITTLE_ENDIAN
                #define TR_ENDIAN_IS_LITTLE
        #endif
#endif /* TARGET_OS_MAC */











#ifdef THIS_IS_NOT_ANSI
#ifdef TR_ALPHA

/* on alpha cpus we can count the cpu cycles.
   this can be used to figure out if sthg can
   be coded faster. */


static inline unsigned int tr_perf_realcc(void)
{
        unsigned long cc;

        /* read the 64bit process cycle count register:
           rpcc (read processor cycle count)
           into variable cc */
        asm volatile("rpcc %0" : "=r"(cc) : : "memory");
        return(cc);
}

/* count just current process */
static inline unsigned int tr_perf_virtcc(void)
{
        unsigned long cc;

        /* read the 64bit process cycle count register (rpcc) into variable cc */
        asm volatile("rpcc %0" : "=r"(cc) : : "memory");
        return((cc + (cc<<32)) >> 32);
}

#endif /* #ifdef TR_ALPHA */
#endif /* #ifdef THIS_IS_NOT_ANSI */
