/**
 * TrueReality - include/memory_extern.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#ifndef __TR_MEMORY_EXTERN_H
#define __TR_MEMORY_EXTERN_H





#include "type_sizes.h"

#ifdef SHM
        #include <X11/Xlib.h>
        #include <X11/extensions/XShm.h>
#endif




#define TR_RDMEM_MASK 0x003fffff
#define TR_RDMEM_MAX  0x00400000



struct tr_mem
{
        char *rd_ram;
        tr_instruction *rd_ram_instr;
        char *sp_dmem;
        tr_instruction *sp_dmem_instr;
        char *sp_imem;
        tr_instruction *sp_imem_instr;
        char *pi_rom;
        char *pi_ram;
        char *pi_ram_w;

        char *rd_reg;
        char *sp_reg;
        char *dpc_reg;
        char *dps_reg;
        char *mi_reg;
        char *mi_reg_w;
        char *vi_reg;
        char *ai_reg;
        char *pi_reg;
        char *pi_reg_w;
        char *ri_reg;
        char *si_reg;
        char *tmem;
        char *null_mem;

        tr_u32    mi_reg_mode_w;
        tr_u32    mi_reg_intr_mask_w;

        tr_u32    sp_reg_pc;
        tr_u32    sp_reg_ibist;

        tr_u32    sp_reg_status_w;

        tr_u32    dpc_reg_status_w;

        tr_u32    pi_reg_status_w;
};


extern  struct  tr_mem  mem;







#ifdef SHM
        struct tr_shminfo
        {
                XShmSegmentInfo rd_ram;
                XShmSegmentInfo rd_ram_instr;
                XShmSegmentInfo sp_dmem;
                XShmSegmentInfo sp_dmem_instr;
                XShmSegmentInfo sp_imem;
                XShmSegmentInfo sp_imem_instr;
                XShmSegmentInfo pi_rom;
                XShmSegmentInfo pi_ram;
                XShmSegmentInfo pi_ram_w;

                XShmSegmentInfo rd_reg;
                XShmSegmentInfo sp_reg;
                XShmSegmentInfo dpc_reg;
                XShmSegmentInfo dps_reg;
                XShmSegmentInfo mi_reg;
                XShmSegmentInfo mi_reg_w;
                XShmSegmentInfo vi_reg;
                XShmSegmentInfo ai_reg;
                XShmSegmentInfo pi_reg;
                XShmSegmentInfo pi_reg_w;
                XShmSegmentInfo ri_reg;
                XShmSegmentInfo si_reg;
                XShmSegmentInfo tmem;
                XShmSegmentInfo null_mem;
        };

        extern  struct  tr_shminfo      shminfo;
#endif





#endif /* #ifndef __TR_MEMORY_EXTERN_H */
