/**
 * TrueReality - include/native.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#ifndef __TYPE_SIZES_H
        #include <type_sizes.h>
#endif





typedef void (*n_fkt)();





#define NUM_OF_NATIVE_ROUTINES 5
extern  tr_u32 native_jal_table[NUM_OF_NATIVE_ROUTINES];
extern  n_fkt native_fkt_table[NUM_OF_NATIVE_ROUTINES];





extern  tr_u32 native_code_set_sr[4];
extern  tr_u32 native_code_get_sr[3];
extern  tr_u32 native_code_disable_interrupts[8];
extern  tr_u32 native_code_restore_interrupts[7];
extern  tr_u32 native_code_set_vi_mode[26];





void    Create_Native_Table();

void    native_nop();
void    native_set_sr();
void    native_get_sr();
void    native_disable_interrupts();
void    native_restore_interrupts();
void    native_set_vi_mode();


