/**
 * TrueReality - input/keyboard/svgalib.c
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <signal.h>
#include <unistd.h>

#include <config.h>
#include <parser_extern.h>
#include <type_sizes.h>
#include <memory_extern.h>
#include <dispatch.h>

#include <vgakeyboard.h>

#include "keyboard.h"

#ifdef DEBUG
        #include <debug.h>
#endif





tr_u32 CheckVisual()
{
        tr_u16    keystate = 0;
        tr_s8    stick_x = 0;
        tr_s8    stick_y = 0;



        if(keyboard_keypressed(SCANCODE_ESCAPE))
        {
                dispatch(SHUTDOWN, 0);
        }

        if(keyboard_keypressed(SCANCODE_F8))
        {
                dispatch(DISPLAY_REFRESH, 0);
        }

        if(keyboard_keypressed(SCANCODE_K))
        {
                stick_y = 64;
        }

        if(keyboard_keypressed(SCANCODE_J))
        {
                stick_y = -64;
        }

        if(keyboard_keypressed(SCANCODE_L))
        {
                stick_x = 64;
        }

        if(keyboard_keypressed(SCANCODE_H))
        {
                stick_x = -64;
        }
        
        keystate =
                keyboard_keypressed(SCANCODE_Q          )?0x1000UL:0 |
                keyboard_keypressed(SCANCODE_W          )?0x8000UL:0 |
                keyboard_keypressed(SCANCODE_E          )?0x4000UL:0 |
                keyboard_keypressed(SCANCODE_HOME       )?0x0008UL:0 |
                keyboard_keypressed(SCANCODE_END        )?0x0004UL:0 |
                keyboard_keypressed(SCANCODE_INSERT     )?0x0001UL:0 |
                keyboard_keypressed(SCANCODE_CURSORUP   )?0x0800UL:0 |
                keyboard_keypressed(SCANCODE_CURSORDOWN )?0x0400UL:0 |
                keyboard_keypressed(SCANCODE_CURSORLEFT )?0x0200UL:0 |
                keyboard_keypressed(SCANCODE_A          )?0x0010UL:0 |
                keyboard_keypressed(SCANCODE_S          )?0x0020UL:0 |
                keyboard_keypressed(SCANCODE_D          )?0x2000UL:0 |
                keyboard_keypressed(SCANCODE_CURSORRIGHT)?0x0100UL:0;
 
#ifdef DEBUG
        if(prefs.debug & DBG_CONTR_BUTTONS)
                printf
                (
                        "Controller: "
                        "0x%04hx %+4d %+4d (0x%08lx) (0xBBBBXXYY) "
                        "%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s\n",

                        keystate, stick_x, stick_y,
                        (tr_u32)(keystate << 16) | ((tr_u32)(tr_u16)(stick_x << 8)) | ((tr_u32)(tr_u8)stick_y),
                        (keystate & 0x8000) ? "A "      : "",
                        (keystate & 0x4000) ? "B "      : "",
                        (keystate & 0x2000) ? "Z "      : "",
                        (keystate & 0x1000) ? "START "  : "",
                        (keystate & 0x0800) ? "Dup "    : "",
                        (keystate & 0x0400) ? "Ddown "  : "",
                        (keystate & 0x0200) ? "Dleft "  : "",
                        (keystate & 0x0100) ? "Dright " : "",
                        (keystate & 0x0080) ? ""        : "",
                        (keystate & 0x0040) ? ""        : "",
                        (keystate & 0x0020) ? "L "      : "",
                        (keystate & 0x0010) ? "R "      : "",
                        (keystate & 0x0008) ? "Cup "    : "",
                        (keystate & 0x0004) ? "Cdown "  : "",
                        (keystate & 0x0002) ? "Cleft "  : "",
                        (keystate & 0x0001) ? "Cright " : "" 
                );
#endif

        return(((tr_u32)(keystate << 16)) | ((tr_u32)(tr_u16)(stick_x << 8)) | ((tr_u32)(tr_u8)stick_y));

} /* tr_u32 CheckVisual() */










