/**
 * TrueReality - io.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#ifndef __TR_IO_H
#define __TR_IO_H




#include <type_sizes.h>





/* where (currently ignored) */
#define TR_IO_CONSOLE    0x0001
#define TR_IO_FILE       0x0002
#define TR_IO_WINDOW     0x0004
#define TR_IO_SERIAL     0x0008
#define TR_IO_EVERYWHERE 0x000f

/* level */
#define TR_IO_NOTHING   0   /* has to be smaller then the other ones! */
#define TR_IO_INFO      1
#define TR_IO_WARNING   2
#define TR_IO_ERROR     3
#define TR_IO_FATAL     4

/* module */
#define TR_IO_CPU       1
#define TR_IO_RSP       2
#define TR_IO_RDP       3
#define TR_IO_HLE       4
#define TR_IO_COMPILE   5
#define TR_IO_QUIT      6

/* ask - how */
#define TR_IO_ASK_YESNO 1
#define TR_IO_ASK_NOYES 2
/* ask - answer */
#define TR_IO_ASK_YES   1
#define TR_IO_ASK_NO    2





void tr_io_set(tr_u32 where, tr_u32 level);   /* currently ignored */

int tr_io_printf(tr_u32 level, tr_u32 module, const char *fmt, ...);

int tr_io_askf(int how, const char *fmt, ...);





#endif /* #ifndef __TR_IO_H */

