/**
 * TrueReality - os/linux/signal.c
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/










#include <signal.h>

#include "../os.h"
#include "../../main.h"
#include "../../N64/registers.h"
#include <parser_extern.h>





static void signal_handler(int signum);





void tr_signals_catch()
{
        signal(SIGINT,  signal_handler);   /* CTRL+C pressed -> cpu halt -> debugger */
        signal(SIGQUIT, signal_handler);
        signal(SIGTERM, signal_handler);
#ifdef TR_DISPLAY
        signal(SIGPIPE, signal_handler);   /* when pipe is broken */
#endif

} /* void tr_signals_catch() */





static void signal_handler(int signum)
{
        signal(signum, SIG_IGN);

        switch(signum)
        {
#ifdef TR_DEBUG
            case SIGINT:
            case SIGQUIT:
                reg.halt = 1;  /* stop cpu */
                break;
#else
            case SIGINT:
            case SIGQUIT:
#endif
            case SIGTERM:
                /* ask for shutting down the emulation */
                tr_shutdown();
                break;

#ifdef TR_DISPLAY
            case SIGPIPE:
                prefs.display = NO_DISPLAY;
                break;
#endif

        } /* switch(signum) */

        signal(signum,  signal_handler);

} /* static void signal_handler(int signum) */






