
// Blitters.c

#include <stdlib.h>
#include <string.h>
#include "memory_extern.h"
#include "type_sizes.h"
#include "config.h"

#include "StandardDisplay.h"
#include "Blitters.h"
#include <DrawSprocket.h>

#define					MAX_WIDTH  640
#define					MAX_HEIGHT 480

extern unsigned short *	mem_rd_ram_Ptr;
extern unsigned long  * mem_vi_reg_1_Ptr;

void BlitOffscreen()		//We are using the QD CopyBits for windows.  All G3's have hardware accel that is faster than
{							//software blitters.  You don't want to run this program on anything less than a G3.
	BeginUpdate(theWindow);	//Unfortunately, there is also the problem with 565-555 conversion, slowing this down.
	EndUpdate(theWindow);
	
	GWorldPtr	oldPort;
	GDHandle	oldDevice;
	
	SetGWorld((CGrafPort *)theWindow, GetMainDevice());
	GetGWorld(&oldPort, &oldDevice);
	
	CopyBits(
		(BitMap *)(*offscreen), 
		&theWindow->portBits, 
		&(**offscreen).bounds, 
		&theWindow->portRect,
		srcCopy, 
		theWindow->visRgn);

	SetGWorld(oldPort, oldDevice);	

}

void
render_image_16_to_15Mac(tr_u16 *imsrc2, tr_u16 *imdst2, int WIDTH, int HEIGHT)
{
    for (short row=0; row<=HEIGHT; row++)
	{
		for (short col=0; col<=WIDTH; col++)
		{
			imdst2[row*width+col]=(imsrc2[row*WIDTH+col]) >> 1;
    	}
    }
}

/*void BlitDouble16(register unsigned int dstRowBytes)	//EA: My try at a double blitter
{
	tr_u16 *Imsrc2 = (tr_u16 *)((tr_u32  *)(mem.rd_ram + ((tr_u32 *)mem.vi_reg)[1]));
	
	short srcNumRow=MAX_HEIGHT/2;
	short srcNumCol=MAX_WIDTH/2;
	
	for (short i=0; i < srcNumRow; i++)
	{
		tr_u16 *src=Imsrc2+i*srcNumCol;
		double *dst1=(double *)dstPtr+(i<<1)*(dstRowBytes >> 3);	//div rb by 8 because we have 8-byte values
		double *dst2=(double *)dstPtr+((i<<1)+1)*(dstRowBytes >> 3);	//Double the i because we row-double
		for (short j=0; j < srcNumCol; j++)
		{
			long pixel1, pixel2;		//The 16 bits of the pixel value twice inside a 32-bit long
			double quadpix;				//2 src pix, 4 dst pixes
			
			pixel1=(long) (*src >> 1);
			pixel1=pixel1 | (pixel1 << 16);
			pixel2=(long) (*(src+1) >> 1);
			pixel2=pixel2 | (pixel2 << 16);
			
			((long *)&quadpix)[0]=pixel1;
			((long *)&quadpix)[1]=pixel2;
			
			*dst1++=quadpix;
			*dst2++=quadpix;
			
			src+=2;
		}
	}
}*/


void BlitLong16(register unsigned int dstRowBytes)				//EA: A long-blitter.  The most efficient of the group
{
	tr_u16 *Imsrc2 = (tr_u16 *)((tr_u32  *)(mem.rd_ram + ((tr_u32 *)mem.vi_reg)[1]));
	
	short srcNumRow=MAX_HEIGHT/2;
	short srcNumCol=MAX_WIDTH/2;
	
	for (short i=0; i < srcNumRow; i++)
	{
		tr_u16 *src=Imsrc2+i*srcNumCol;
		unsigned long *dst1=(unsigned long *)dstPtr+(i<<1)*(dstRowBytes >> 2);	//div rb by 4 because we have 4-byte values
		unsigned long *dst2=(unsigned long *)dstPtr+((i<<1)+1)*(dstRowBytes >> 2);	//Double the i because we row-double
		for (short j=0; j < srcNumCol; j++)
		{
			unsigned long pixel;
			unsigned long doublepix;
			
			pixel=*src;
			pixel>>=1;
			doublepix=pixel | (pixel << 16);
			*dst1++=doublepix;
			*dst2++=doublepix;
			src++;
		}
	}
}



#ifndef PPC
void BlitDouble16(register unsigned int dstRowBytes)
{
	register unsigned short i,j;
	register unsigned short pixel;
	register unsigned long pixels;
	register double blitPixels;
	
	tr_u16 *Imsrc2 = (tr_u16 *)((tr_u32  *)(mem.rd_ram + ((tr_u32 *)mem.vi_reg)[1]));

	for (i = 0; i < MAX_WIDTH/2; i++)
	{
		register unsigned short *p = (Imsrc2 + i*(MAX_WIDTH/2));
		register unsigned long  *q = (unsigned long*)(dstPtr + (i*dstRowBytes/2)*2);
		
		for (j = 0; j < MAX_HEIGHT/2; j +=2)
		{
			pixel = *p;
			pixels = pixel << 16;
			pixels |= pixel;
			pixels >>= 1;
			((unsigned long*)&blitPixels)[0] = pixels;

			pixel = *(p+1);
			pixels = pixel << 16;
			pixels |= pixel;
			pixels >>= 1;
			((unsigned long*)&blitPixels)[1] = pixels;

			*(double *)q = blitPixels;
			*(double *)(q+dstRowBytes/4) = blitPixels;
			
			p += 2;
			q += 2;
		}
	}
}
#else

#define TARGET			r4
#define SOURCE			r5
#define MEM				r6
#define dstEmptRowBytes	r7
#define OFFSET			r8		// mem.vi_reg[1]
#define PIXEL			r9

#define	I				r10
#define	J				r11
#define WriteReg		r12
#define temp			r0

typedef tr_mem tr_mem;

asm void BlitDouble16(register unsigned int dstRowBytes)
{
	// Load Global pointers
	lwz		MEM, mem(RTOC);						// MEM = mem
	lwz		TARGET, dstPtr(RTOC);				// Get destinationPtr
	lwz		OFFSET, tr_mem.vi_reg(MEM);
	subi	dstEmptRowBytes, dstRowBytes, 640;
	lwz		SOURCE, tr_mem.rd_ram(MEM)			// SOURCE = mem.rd_ram
	lwz		TARGET, 0(TARGET);					// TARGET = dstPtr = (**theVideoBuffer->portPixMap).baseAddr
	lwz		OFFSET, 4(OFFSET);					// OFFSET = mem.vi_reg[1]
	slwi	dstEmptRowBytes, dstEmptRowBytes, 1;
	add		SOURCE, SOURCE, OFFSET;				// Calculate source pointer	
	
	li		I,0;
@2:	li		J,0;
	
	// Blast 1'st pixel
@1:	lwzx	PIXEL, SOURCE, J;
	addi	J, J, 4;
	srwi	PIXEL, PIXEL, 1;
	clrrwi	WriteReg, PIXEL, 16;
	srwi	temp, PIXEL, 16;
	or		WriteReg, WriteReg, temp;
	stw		WriteReg, -16(SP);

	// Blast 2'nd pixel	
	clrlwi	temp, PIXEL, 16;
	slwi	PIXEL, PIXEL, 16;
	or		WriteReg, temp, PIXEL;
	stw		WriteReg, -12(SP);
	
	// Blast combined pixel onto the target
	lfd		fp0, -16(SP);
	cmplwi	J, MAX_WIDTH;	
	stfd	fp0, 0(TARGET);
	stfdx	fp0, TARGET, dstRowBytes;
	addi	TARGET, TARGET, 8;
	
	blt+	@1;
	
	addi	I, I, 1;
	cmplwi	I, MAX_HEIGHT/2;
	addi	SOURCE, SOURCE, MAX_WIDTH;
	add		TARGET, TARGET, dstEmptRowBytes;
	blt+	@2;
	
	// Return
	blr;
}
#endif

void Blit16(register unsigned int dstRowBytes)
{
	register unsigned short i,j;
	register unsigned long pixels;
	register double blitPixels;
	
	tr_u16 *Imsrc2 = (tr_u16 *) (mem.rd_ram + ((tr_u32 *)mem.vi_reg)[1]);

	for (i = 0; i < MAX_HEIGHT; i++)
	{
		register unsigned long *p = (unsigned long*)(Imsrc2 + i*MAX_WIDTH);
		register unsigned short *q = (unsigned short*)(dstPtr + (i*dstRowBytes/2));
		
		for (j = 0; j < MAX_WIDTH; j += 4)
		{
			pixels = *p;
			pixels >>= 1;
			((unsigned long*)&blitPixels)[0] = pixels;

			pixels = *(p + 1);
			pixels >>= 1;
			((unsigned long*)&blitPixels)[1] = pixels;

			*(double *)q = blitPixels;
			
			p += 2;
			q += 4;
		}
	}
}

void BlitDouble32(register unsigned int dstRowBytes)
{
	register unsigned short i,j;
	register short pixel;
	register unsigned long longPixel;
	register unsigned int dstRowShorts = dstRowBytes/2;
	register unsigned int dstRowLongs = dstRowShorts/2;
	
	unsigned long *Imsrc = (unsigned long *) (mem.rd_ram + ((tr_u32 *)mem.vi_reg)[1]);

	for (i = 0; i < 240; i++)
	{
		for (j = 0; j < 320; j +=2)
		{
			register unsigned long *p = (Imsrc + i*320 + j);
			register unsigned long *q = (unsigned long*)(dstPtr + (i*dstRowShorts + j)*2);
			longPixel = *p;
			pixel = ((longPixel & 0xF8) >> 3) | ((longPixel & 0xF800) >> 6) | ((longPixel & 0xF80000) >> 9);
			*q = (pixel << 16) | pixel;
			longPixel = *(p+1);
			pixel = ((longPixel & 0xF8) >> 3) | ((longPixel & 0xF800) >> 6) | ((longPixel & 0xF80000) >> 9);
			*(q+1) = (pixel << 16) | pixel;
			*(double *)(q+dstRowLongs) = *(double *)q;
		}
	}
}

void Blit32(register unsigned int dstRowBytes)
{
	register unsigned short i,j;
	register long pixel;
	register unsigned long longPixel;
	register unsigned int dstRowLongs = dstRowBytes/4;
	
	unsigned long *Imsrc = (unsigned long *) (mem.rd_ram + ((tr_u32 *)mem.vi_reg)[1]);
	for (i = 0; i < MAX_HEIGHT; i++)
	{
		for (j = 0; j < MAX_WIDTH; j += 2)
		{
			register unsigned long *p = (Imsrc + i*MAX_WIDTH + j);
			longPixel = *p;
			pixel = ((longPixel & 0xF8) >> 3) | ((longPixel & 0xF800) >> 6) | ((longPixel & 0xF80000) >> 9) << 16;
			longPixel = *(p+1);
			pixel |= ((longPixel & 0xF8) >> 3) | ((longPixel & 0xF800) >> 6) | ((longPixel & 0xF80000) >> 9);
//			*((unsigned long *)dstPtr + (i*dstRowLongs + j)) = pixelTable[*(p)] << 16 | pixelTable[*(p+1)];
		}
	}
}

extern unsigned short rowBytes;
unsigned short *gOldArea;

void BlitPause(unsigned short* srcPtr, unsigned int theWidth, unsigned int theHeight, unsigned short srcRowBytes)
{
	register unsigned int x, y;	
	unsigned long	offsetX = 320 - theWidth/2;
	unsigned long	offsetY = 240 - theHeight/2;
	signed char		R, G, B, R2, G2, B2;
	unsigned short	pixel;
	signed char		Val;
	
	register unsigned short *p = dstPtr;
	p += offsetX + offsetY*rowBytes/2;
	
	gOldArea = (unsigned short *)malloc(theWidth*theHeight*2);
	
	for (y = 0; y<theHeight; y++)
	{
		for (x = 0; x<theWidth; x++)
		{
			if(gOldArea != NULL)
				*(gOldArea + y*theWidth + x) = *p;
			pixel = *(srcPtr + x + y*srcRowBytes/2);
			B = pixel & 0x1F;
			G = (pixel >> 5) & 0x1F;
			R = (pixel >> 10) & 0x1F;
			if (((abs(B-R) < 3) && (abs((B+R)/2 - G) > 0x4)) || (G - (B+R)/2 > 0x4))
			{
				pixel = *p;
				B2 = pixel & 0x1F;
				G2 = (pixel >> 5) & 0x1F;
				R2 = (pixel >> 10) & 0x1F;
				
				Val = (B + (R-B)/2) - (0x1F-G);
				
				if((R = (R2+Val)) > 0x1F) R = 0x1F;
				else if (R < 0) R = 0;
				
				if((G = (G2+Val)) > 0x1F) G = 0x1F;
				else if (G < 0) G = 0;
				
				if((B = (B2+Val)) > 0x1F) B = 0x1F;
				else if (B < 0) B = 0;
					
				*p = (unsigned short)((R << 10) | (G << 5) | B);
			}
			else
			{
				*p = pixel;
			}
			p++;
		}
		p += rowBytes/2-theWidth;
	}
}

bool UnBlitPause(unsigned int theWidth, unsigned int theHeight)
{
	register unsigned int x, y;	
	unsigned long	offsetX = 320 - theWidth/2;
	unsigned long	offsetY = 240 - theHeight/2;
	signed char		R, G, B, R2, G2, B2;
	unsigned short	pixel;
	signed char		Val;
	
	if(gOldArea == NULL)
	{
		return false;
	}
	
	register unsigned short *p = dstPtr;
	p += offsetX + offsetY*rowBytes/2;
	
	for (y = 0; y<theHeight; y++)
	{
		for (x = 0; x<theWidth; x++)
		{
			*p = *(gOldArea + y*theWidth + x);
			
			p++;
		}
		p += rowBytes/2-theWidth;
	}
	
	free(gOldArea);
	
	return true;
}

int SaveScreen(FSSpec* theFile)
{
	CGrafPtr		theScreen;
	GWorldPtr		theWorld;
	PicHandle		thePicture;
	Rect			screenSize = {0, 0, 0, 0};
	GrafPtr			oldPort;
	GDHandle		oldGD;
	GWorldPtr		oldGW;
	unsigned long	GWRowBytes;
	unsigned short	*p, *q;
	FSSpec 			tempFile;
	short			fRefNum;
	long			writelength;
	OSErr			err;
	int				i;
	
	screenSize.bottom   = 480;
	screenSize.right    = 640;
	
	NewGWorld(	&theWorld, 16, &screenSize, nil, nil, 0L );
	LockPixels( theWorld->portPixMap );
	
	// Blit the current image onto our GWorld
	err = DSpContext_GetFrontBuffer(theContext, &theScreen);
	if (err != noErr)
		return noErr;
	p = (unsigned short *)(**theScreen->portPixMap).baseAddr;
	q = (unsigned short *)(**theWorld->portPixMap).baseAddr;
	GWRowBytes = (**theWorld->portPixMap).rowBytes & 0x3fff;
	
	for (i = 0; i < 480; i++)
	{
		memcpy(q, p, 640*2);
		q += GWRowBytes/2;
		p += rowBytes/2;
	}
	
	GetPort(&oldPort);
	GetGWorld(&oldGW, &oldGD);
	SetGWorld(theWorld, nil);

	thePicture = OpenPicture(&screenSize);
	CopyBits((BitMap*) &theWorld->portPixMap, (BitMap*) &theWorld->portPixMap,
					&screenSize, &screenSize,
					srcCopy, nil );

	ClosePicture();
	
	SetGWorld(oldGW, oldGD);
	SetPort(oldPort);
	
	if (theFile == NULL)
	{
		unsigned char	tempStr[33] = "\pScreenshot ??";
		FInfo			fileInfo;
		
		for (i = 1; i <= 99; i++)
		{
			if (i < 10)
			{
				tempStr[0] = 12;
				tempStr[12] = i+'0';
			}
			else
			{
				tempStr[0] = 13;
				
				tempStr[12] = (i/10)+'0';
				tempStr[13] = i-((i/10)*10)+'0';
			}
			FSMakeFSSpec(-1, 2, tempStr, &tempFile);
			err = FSpGetFInfo(&tempFile, &fileInfo);
			if (err == fnfErr)
				break;
			else if (err != noErr)
			{
				DisposeGWorld(theWorld);
				return -1;
			}
		}
		theFile = &tempFile;
	}
	FSpCreateResFile(theFile, '8BIM', 'SCRN', smSystemScript );

	fRefNum = FSpOpenResFile(theFile, fsWrPerm);
	AddResource((Handle)thePicture, 'PICT', 128, "\p");
	WriteResource((Handle)thePicture);
	ReleaseResource((Handle)thePicture);
	CloseResFile(fRefNum);
	
	DisposeGWorld(theWorld);
	return noErr;
}

