/**
 * TrueReality - output/display/renderer.h
 * Copyright (C) 1998, 1999 by Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





/* matrix */

void tr_ren_load_modelview(float m[4][4]);
void tr_ren_load_projection(float m[4][4]);
void tr_ren_mul_modelview(float m[4][4]);
void tr_ren_mul_projection(float m[4][4]);
void tr_ren_push_load_modelview(float m[4][4]);
void tr_ren_push_mul_modelview(float m[4][4]);
void tr_ren_pop_modelview();



/* view */

void tr_ren_viewport();
void tr_ren_lookat_x();
void tr_ren_lookat_y();



/* light */

#define TR_REN_LIGHTNING_OFF 0
#define TR_REN_LIGHTNING_ON  1
void tr_ren_lightning(int on);
void tr_ren_light(int n);
void tr_ren_numlights();
void tr_ren_lightcol(int n);



/* primitives */

void tr_ren_line3d(int vn[]);
void tr_ren_tri1(int vn[]);
void tr_ren_tri2(int vn[]);
void tr_ren_rect(int vn[]);



/* misc */

#define TR_REN_ALPHA_OFF 0
#define TR_REN_ALPHA_ON  1
void tr_ren_alpha(int on);

#define TR_REN_CULL_OFF 0
#define TR_REN_CULL_FRONT  1
#define TR_REN_CULL_BACK  2
void tr_ren_cull(int how);

#define TR_REN_TEXTURE_OFF     0
#define TR_REN_TEXTURE_ON      1
#define TR_REN_TEXTURE_REFLECT 2
void tr_ren_texture(int how);

#define TR_REN_ZBUFFER_OFF 0
#define TR_REN_ZBUFFER_ON  1
void tr_ren_zbuffer(int on);

