#include <stdio.h>
#include <type_sizes.h>
#include <compile_static_extern.h>
#include <file_loader_extern.h>
#include <parser_extern.h>
#include "N64/registers.h"
#include "N64/compile_static_mnemonic.h"
#include "N64/compile_static.h"





tr_instruction *tr_i;
struct rs4300i_reg reg;
struct tr_rom rom;
struct tr_prefs prefs;


int main()
{
        tr_u32         j, k;
        tr_u32         c[300];
        tr_instruction i[300];



        /* special */
        c[0]   = TR_A_NOP();
        c[1]   = TR_A_CLR(1);
        c[2]   = TR_A_SLL(4, 3, 2);
        c[3]   = TR_A_SRL(4, 3, 2);
        c[4]   = TR_A_SRA(4, 3, 2);
        c[5]   = TR_A_SLLV(4, 3, 2);
        c[6]   = TR_A_SRLV(4, 3, 2);
        c[7]   = TR_A_SRAV(4, 3, 2);
        c[8]   = TR_A_JR(4);
        c[9]   = TR_A_JALR(4, 3);
        c[10]  = TR_A_SYSCALL();
        c[11]  = TR_A_BREAK();
        c[12]  = TR_A_SYNC();
        c[13]  = TR_A_MFHI(4);
        c[14]  = TR_A_MTHI(4);
        c[15]  = TR_A_MFLO(4);
        c[16]  = TR_A_MTLO(4);
        c[17]  = TR_A_DSLLV(4, 3, 2);
        c[18]  = TR_A_DSRLV(4, 3, 2);
        c[19]  = TR_A_DSRAV(4, 3, 2);
        c[20]  = TR_A_MULT(4, 3);
        c[21]  = TR_A_MULTU(4, 3);
        c[22]  = TR_A_DIV(4, 3);
        c[23]  = TR_A_DIVU(4, 3);
        c[24]  = TR_A_DMULT(4, 3);
        c[25]  = TR_A_DMULTU(4, 3);
        c[26]  = TR_A_DDIV(4, 3);
        c[27]  = TR_A_DDIVU(4, 3);
        c[28]  = TR_A_ADD(4, 3, 2);
        c[29]  = TR_A_ADDU(4, 3, 2);
        c[30]  = TR_A_SUB(4, 3, 2);
        c[31]  = TR_A_SUBU(4, 3, 2);
        c[32]  = TR_A_AND(4, 3, 2);
        c[33]  = TR_A_OR(4, 3, 2);
        c[34]  = TR_A_XOR(4, 3, 2);
        c[35]  = TR_A_NOR(4, 3, 2);
        c[36]  = TR_A_SLT(4, 3, 2);
        c[37]  = TR_A_SLTU(4, 3, 2);
        c[38]  = TR_A_DADD(4, 3, 2);
        c[39]  = TR_A_DADDU(4, 3, 2);
        c[40]  = TR_A_DSUB(4, 3, 2);
        c[41]  = TR_A_DSUBU(4, 3, 2);
        c[42]  = TR_A_TGE(4, 3);
        c[43]  = TR_A_TGEU(4, 3);
        c[44]  = TR_A_TLT(4, 3);
        c[45]  = TR_A_TLTU(4, 3);
        c[46]  = TR_A_TEQ(4, 3);
        c[47]  = TR_A_TNE(4, 3);
        c[48]  = TR_A_DSLL(4, 3, 2);
        c[49]  = TR_A_DSRL(4, 3, 2);
        c[50]  = TR_A_DSRA(4, 3, 2);
        c[51]  = TR_A_DSLL32(4, 3, 2);
        c[52]  = TR_A_DSRL32(4, 3, 2);
        c[53]  = TR_A_DSRA32(4, 3, 2);

        /* regimm */
        c[54]  = TR_A_BLTZ(4, -5);
        c[55]  = TR_A_BGEZ(4, -5);
        c[56]  = TR_A_BLTZL(4, -5);
        c[57]  = TR_A_BGEZL(4, -5);
        c[58]  = TR_A_TGEI(4, 3);
        c[59]  = TR_A_TGEIU(4, 3);
        c[60]  = TR_A_TLTI(4, 3);
        c[61]  = TR_A_TLTIU(4, 3);
        c[62]  = TR_A_TEQI(4, 3);
        c[63]  = TR_A_TNEI(4, 3);
        c[64]  = TR_A_BLTZAL(4, -5);
        c[65]  = TR_A_BGEZAL(4, -5);
        c[66]  = TR_A_BLTZALL(4, -5);
        c[67]  = TR_A_BGEZALL(4, -5);

        /* general */
        c[68]  = TR_A_J(4);
        c[69]  = TR_A_JAL(4);
        c[70]  = TR_A_BEQ(4, 3, -2);
        c[71]  = TR_A_BNE(4, 3, -2);
        c[72]  = TR_A_BLEZ(4, 3, -2);
        c[73]  = TR_A_BGTZ(4, 3, -2);
        c[74]  = TR_A_ADDI(4, 3, 2);
        c[75]  = TR_A_ADDIU(4, 3, 2);
        c[76]  = TR_A_SLTI(4, 3, 2);
        c[77]  = TR_A_SLTIU(4, 3, 2);
        c[78]  = TR_A_ANDI(4, 3, 2);
        c[79]  = TR_A_ORI(4, 3, 2);
        c[80]  = TR_A_XORI(4, 3, 2);
        c[81]  = TR_A_LUI(4, 3);
        c[82]  = TR_A_BEQL(4, 3, -2);
        c[83]  = TR_A_BNEL(4, 3, -2);
        c[84]  = TR_A_BLEZL(4, 3, -2);
        c[85]  = TR_A_BGTZL(4, 3, -2);
        c[86]  = TR_A_DADDI(4, 3, 2);
        c[87]  = TR_A_DADDIU(4, 3, 2);
        c[88]  = TR_A_LDL(4, -3, 2);
        c[89]  = TR_A_LDR(4, -3, 2);
        c[90]  = TR_A_LB(4, -3, 2);
        c[91]  = TR_A_LH(4, -3, 2);
        c[92]  = TR_A_LWL(4, -3, 2);
        c[93]  = TR_A_LW(4, -3, 2);
        c[94]  = TR_A_LBU(4, -3, 2);
        c[95]  = TR_A_LHU(4, -3, 2);
        c[96]  = TR_A_LWR(4, -3, 2);
        c[97]  = TR_A_LWU(4, -3, 2);
        c[98]  = TR_A_SB(4, -3, 2);
        c[99]  = TR_A_SH(4, -3, 2);
        c[100] = TR_A_SWL(4, -3, 2);
        c[101] = TR_A_SW(4, -3, 2);
        c[102] = TR_A_SDL(4, -3, 2);
        c[103] = TR_A_SDR(4, -3, 2);
        c[104] = TR_A_SWR(4, -3, 2);
        c[105] = TR_A_CACHE(4, -3, 2);
        c[106] = TR_A_LL(4, -3, 2);
        c[107] = TR_A_LWC1(4, -3, 2);
        c[108] = TR_A_LWC2(4, -3, 2);
        c[109] = TR_A_LLD(4, -3, 2);
        c[110] = TR_A_LDC1(4, -3, 2);
        c[111] = TR_A_LDC2(4, -3, 2);
        c[112] = TR_A_LD(4, -3, 2);
        c[113] = TR_A_SC(4, -3, 2);
        c[114] = TR_A_SWC1(4, -3, 2);
        c[115] = TR_A_SWC2(4, -3, 2);
        c[116] = TR_A_SCD(4, -3, 2);
        c[117] = TR_A_SDC1(4, -3, 2);
        c[118] = TR_A_SDC2(4, -3, 2);
        c[119] = TR_A_SD(4, -3, 2);

        /* cop0 (tlb/eret) */
        c[120] = TR_A_MFC0(4,3);
        c[121] = TR_A_DMFC0(4,3);
        c[122] = TR_A_CFC0(4,3);
        c[123] = TR_A_MTC0(4,3);
        c[124] = TR_A_DMTC0(4,3);
        c[125] = TR_A_CTC0(4,3);
        c[126] = TR_A_BC0F(-4);
        c[127] = TR_A_BC0T(-4);
        c[128] = TR_A_BC0FL(-4);
        c[129] = TR_A_BC0TL(-4);
        c[130] = TR_A_cop0_TLBR();
        c[131] = TR_A_cop0_TLBWI();
        c[132] = TR_A_cop0_TLBWR();
        c[133] = TR_A_cop0_TLBP();
        c[134] = TR_A_cop0_ERET();

        /* cop1 (fpu) */
        c[135] = TR_A_MFC1(4,3);
        c[136] = TR_A_DMFC1(4,3);
        c[137] = TR_A_CFC1(4,3);
        c[138] = TR_A_MTC1(4,3);
        c[139] = TR_A_DMTC1(4,3);
        c[140] = TR_A_CTC1(4,3);
        c[141] = TR_A_BC1F(-4);
        c[142] = TR_A_BC1T(-4);
        c[143] = TR_A_BC1FL(-4);
        c[144] = TR_A_BC1TL(-4);
        c[145] = TR_A_cop1_ADD_s(4,3,2);
        c[146] = TR_A_cop1_ADD_d(4,3,2);
        c[147] = TR_A_cop1_SUB_s(4,3,2);
        c[148] = TR_A_cop1_SUB_d(4,3,2);
        c[149] = TR_A_cop1_MUL_s(4,3,2);
        c[150] = TR_A_cop1_MUL_d(4,3,2);
        c[151] = TR_A_cop1_DIV_s(4,3,2);
        c[152] = TR_A_cop1_DIV_d(4,3,2);
        c[153] = TR_A_cop1_SQRT_s(4,3);
        c[154] = TR_A_cop1_SQRT_d(4,3);
        c[155] = TR_A_cop1_ABS_s(4,3);
        c[156] = TR_A_cop1_ABS_d(4,3);
        c[157] = TR_A_cop1_MOV_s(4,3);
        c[158] = TR_A_cop1_MOV_d(4,3);
        c[159] = TR_A_cop1_NEG_s(4,3);
        c[160] = TR_A_cop1_NEG_d(4,3);
        c[161] = TR_A_cop1_ROUNDl_s(4,3);
        c[162] = TR_A_cop1_ROUNDl_d(4,3);
        c[163] = TR_A_cop1_TRUNCl_s(4,3);
        c[164] = TR_A_cop1_TRUNCl_d(4,3);
        c[165] = TR_A_cop1_CEILl_s(4,3);
        c[166] = TR_A_cop1_CEILl_d(4,3);
        c[167] = TR_A_cop1_FLOORl_s(4,3);
        c[168] = TR_A_cop1_FLOORl_d(4,3);
        c[169] = TR_A_cop1_ROUNDw_s(4,3);
        c[170] = TR_A_cop1_ROUNDw_d(4,3);
        c[171] = TR_A_cop1_TRUNCw_s(4,3);
        c[172] = TR_A_cop1_TRUNCw_d(4,3);
        c[173] = TR_A_cop1_CEILw_s(4,3);
        c[174] = TR_A_cop1_CEILw_d(4,3);
        c[175] = TR_A_cop1_FLOORw_s(4,3);
        c[176] = TR_A_cop1_FLOORw_d(4,3);
        c[177] = TR_A_cop1_CVTs_d(4,3);
        c[178] = TR_A_cop1_CVTs_w(4,3);
        c[179] = TR_A_cop1_CVTs_l(4,3);
        c[180] = TR_A_cop1_CVTd_s(4,3);
        c[181] = TR_A_cop1_CVTd_w(4,3);
        c[182] = TR_A_cop1_CVTd_l(4,3);
        c[183] = TR_A_cop1_CVTw_s(4,3);
        c[184] = TR_A_cop1_CVTw_d(4,3);
        c[185] = TR_A_NOP();
        c[186] = TR_A_cop1_CVTl_s(4,3);
        c[187] = TR_A_cop1_CVTl_d(4,3);
        c[188] = TR_A_NOP();
        c[189] = TR_A_cop1_CF_s(4,3);
        c[190] = TR_A_cop1_CF_d(4,3);
        c[191] = TR_A_cop1_CUN_s(4,3);
        c[192] = TR_A_cop1_CUN_d(4,3);
        c[193] = TR_A_cop1_CEQ_s(4,3);
        c[194] = TR_A_cop1_CEQ_d(4,3);
        c[195] = TR_A_cop1_CUEQ_s(4,3);
        c[196] = TR_A_cop1_CUEQ_d(4,3);
        c[197] = TR_A_cop1_COLT_s(4,3);
        c[198] = TR_A_cop1_COLT_d(4,3);
        c[199] = TR_A_cop1_CULT_s(4,3);
        c[200] = TR_A_cop1_CULT_d(4,3);
        c[201] = TR_A_cop1_COLE_s(4,3);
        c[202] = TR_A_cop1_COLE_d(4,3);
        c[203] = TR_A_cop1_CULE_s(4,3);
        c[204] = TR_A_cop1_CULE_d(4,3);
        c[205] = TR_A_cop1_CSF_s(4,3);
        c[206] = TR_A_cop1_CSF_d(4,3);
        c[207] = TR_A_cop1_CNGLE_s(4,3);
        c[208] = TR_A_cop1_CNGLE_d(4,3);
        c[209] = TR_A_cop1_CSEQ_s(4,3);
        c[210] = TR_A_cop1_CSEQ_d(4,3);
        c[211] = TR_A_cop1_CNGL_s(4,3);
        c[212] = TR_A_cop1_CNGL_d(4,3);
        c[213] = TR_A_cop1_CLT_s(4,3);
        c[214] = TR_A_cop1_CLT_d(4,3);
        c[215] = TR_A_cop1_CNGE_s(4,3);
        c[216] = TR_A_cop1_CNGE_d(4,3);
        c[217] = TR_A_cop1_CLE_s(4,3);
        c[218] = TR_A_cop1_CLE_d(4,3);
        c[219] = TR_A_cop1_CNGT_s(4,3);
        c[220] = TR_A_cop1_CNGT_d(4,3);

        /* cop2 (not used) */



        for(j=221; j<300; j++)
        {
                c[j] = TR_A_NOP();
        }


        prefs.debug = 0xff;
        for(j=0; j<300; j++)
        {
                tr_compile_tab[TR_COMPILE_OPCODE(c[j])](c[j], &i[j]);
        }

        prefs.debug = 0x00;
        for(k=0; k<0x10000; k++)
        {
                tr_i = i;
                for(j=0; j<200; j++)
                {
                        tr_i->r.f();
                        tr_i++;
                }
        }

        return(0);
}
